<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (version 1.7.0_80) on Wed Sep 20 14:52:11 UTC 2017 -->
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>PublishingExtension (Gradle API 4.2)</title>
<meta name="date" content="2017-09-20">
<link rel="stylesheet" type="text/css" href="../../../../javadoc.css" title="Style">
</head>
<body>
<script type="text/javascript"><!--
    if (location.href.indexOf('is-external=true') == -1) {
        parent.document.title="PublishingExtension (Gradle API 4.2)";
    }
//-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar_top">
<!--   -->
</a><a href="#skip-navbar_top" title="Skip navigation links"></a><a name="navbar_top_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-all.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../org/gradle/api/publish/PublicationContainer.html" title="interface in org.gradle.api.publish"><span class="strong">Prev Class</span></a></li>
<li>Next Class</li>
</ul>
<ul class="navList">
<li><a href="../../../../index.html?org/gradle/api/publish/PublishingExtension.html" target="_top">Frames</a></li>
<li><a href="PublishingExtension.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field_summary">Field</a>&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field_detail">Field</a>&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">org.gradle.api.publish</div>
<h2 title="Interface PublishingExtension" class="title">Interface PublishingExtension</h2>
</div>
<div class="contentContainer">
<div class="description">
<ul class="blockList">
<li class="blockList">
<hr>
<br>
<pre><a href="../../../../org/gradle/api/Incubating.html" title="annotation in org.gradle.api">@Incubating</a>
public interface <span class="strong">PublishingExtension</span></pre>
<div class="block">The configuration of how to “publish” the different components of a project.
 <p>
 This new publishing mechanism will eventually replace the current mechanism of upload tasks and configurations. At this time, it is an
 incubating feature and under development.

 <p>
 The PublishingExtension is a <a href="../../../../org/gradle/api/plugins/DeferredConfigurable.html" title="annotation in org.gradle.api.plugins"><code>DeferredConfigurable</code></a> model element, meaning that extension will be configured as late as possible in the build.
 So any 'publishing' configuration blocks are not evaluated until either:
 <ol>
     <li>The project is about to execute, or</li>
     <li>he publishing extension is referenced as an instance, as opposed to via a configuration closure.</li>
 </ol>
 <p>
 A 'publishing' configuration block does not need to dereference the publishing extension, and so will be evaluated late. eg:
 <pre>
     publishing {
         publications { ... }
         repositories.maven { ... }
     }
 </pre>

 <p>
 Any use that accesses the publishing extension as an instance does require the publishing extension to be realised, forcing all configuration blocks to be evaluated. eg:
 <pre>
     publishing.publications { ... }
     publishing.repositories.maven { ... }
 </pre></div>
<dl><dt><span class="strong">Since:</span></dt>
  <dd>1.3</dd></dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- =========== FIELD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="field_summary">
<!--   -->
</a>
<h3>Field Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Field Summary table, listing fields, and an explanation">
<caption><span>Fields</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Field and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>static <a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/publish/PublishingExtension.html#NAME">NAME</a></strong></code>
<div class="block">The name of this extension when installed by the <a href="../../../../org/gradle/api/publish/plugins/PublishingPlugin.html" title="class in org.gradle.api.publish.plugins"><code>PublishingPlugin</code></a> ("publishing").</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method_summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span>Methods</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/publish/PublicationContainer.html" title="interface in org.gradle.api.publish">PublicationContainer</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/publish/PublishingExtension.html#getPublications()">getPublications</a></strong>()</code>
<div class="block">The publications of the project.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/artifacts/dsl/RepositoryHandler.html" title="interface in org.gradle.api.artifacts.dsl">RepositoryHandler</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/publish/PublishingExtension.html#getRepositories()">getRepositories</a></strong>()</code>
<div class="block">The container of possible repositories to publish to.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/publish/PublishingExtension.html#publications(org.gradle.api.Action)">publications</a></strong>(<a href="../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../org/gradle/api/publish/PublicationContainer.html" title="interface in org.gradle.api.publish">PublicationContainer</a>&gt;&nbsp;configure)</code>
<div class="block">Configures the publications of this project.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/publish/PublishingExtension.html#repositories(org.gradle.api.Action)">repositories</a></strong>(<a href="../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../org/gradle/api/artifacts/dsl/RepositoryHandler.html" title="interface in org.gradle.api.artifacts.dsl">RepositoryHandler</a>&gt;&nbsp;configure)</code>
<div class="block">Configures the container of possible repositories to publish to.</div>
</td>
</tr>
</table>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ FIELD DETAIL =========== -->
<ul class="blockList">
<li class="blockList"><a name="field_detail">
<!--   -->
</a>
<h3>Field Detail</h3>
<a name="NAME">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>NAME</h4>
<pre>static final&nbsp;<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a> NAME</pre>
<div class="block">The name of this extension when installed by the <a href="../../../../org/gradle/api/publish/plugins/PublishingPlugin.html" title="class in org.gradle.api.publish.plugins"><code>PublishingPlugin</code></a> ("publishing").</div>
<dl><dt><span class="strong">See Also:</span></dt><dd><a href="../../../../constant-values.html#org.gradle.api.publish.PublishingExtension.NAME">Constant Field Values</a></dd></dl>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method_detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="getRepositories()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getRepositories</h4>
<pre><a href="../../../../org/gradle/api/artifacts/dsl/RepositoryHandler.html" title="interface in org.gradle.api.artifacts.dsl">RepositoryHandler</a>&nbsp;getRepositories()</pre>
<div class="block">The container of possible repositories to publish to.
 <p>
 See <a href="../../../../org/gradle/api/publish/PublishingExtension.html#repositories(org.gradle.api.Action)"><code>repositories(org.gradle.api.Action)</code></a> for more information.</div>
<dl><dt><span class="strong">Returns:</span></dt><dd>The container of possible repositories to publish to.</dd></dl>
</li>
</ul>
<a name="repositories(org.gradle.api.Action)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>repositories</h4>
<pre>void&nbsp;repositories(<a href="../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../org/gradle/api/artifacts/dsl/RepositoryHandler.html" title="interface in org.gradle.api.artifacts.dsl">RepositoryHandler</a>&gt;&nbsp;configure)</pre>
<div class="block">Configures the container of possible repositories to publish to.

 <pre class='autoTested'>
 apply plugin: 'publishing'

 publishing {
   repositories {
     // Create an ivy publication destination named “releases”
     ivy {
       name "releases"
       url "http://my.org/ivy-repos/releases"
     }
   }
 }
 </pre>

 The <code>repositories</code> block is backed by a <a href="../../../../org/gradle/api/artifacts/dsl/RepositoryHandler.html" title="interface in org.gradle.api.artifacts.dsl"><code>RepositoryHandler</code></a>, which is the same DSL as that that is used for declaring repositories to consume dependencies from. However,
 certain types of repositories that can be created by the repository handler are not valid for publishing, such as <a href="../../../../org/gradle/api/artifacts/dsl/RepositoryHandler.html#mavenCentral()"><code>RepositoryHandler.mavenCentral()</code></a>.
 <p>
 At this time, only repositories created by the <code>ivy()</code> factory method have any effect. Please see <a href="../../../../org/gradle/api/publish/ivy/IvyPublication.html" title="interface in org.gradle.api.publish.ivy"><code>IvyPublication</code></a>
 for information on how this can be used for publishing to Ivy repositories.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>configure</code> - The action to configure the container of repositories with.</dd></dl>
</li>
</ul>
<a name="getPublications()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getPublications</h4>
<pre><a href="../../../../org/gradle/api/publish/PublicationContainer.html" title="interface in org.gradle.api.publish">PublicationContainer</a>&nbsp;getPublications()</pre>
<div class="block">The publications of the project.
 <p>
 See <a href="../../../../org/gradle/api/publish/PublishingExtension.html#publications(org.gradle.api.Action)"><code>publications(org.gradle.api.Action)</code></a> for more information.</div>
<dl><dt><span class="strong">Returns:</span></dt><dd>The publications of this project.</dd></dl>
</li>
</ul>
<a name="publications(org.gradle.api.Action)">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>publications</h4>
<pre>void&nbsp;publications(<a href="../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../org/gradle/api/publish/PublicationContainer.html" title="interface in org.gradle.api.publish">PublicationContainer</a>&gt;&nbsp;configure)</pre>
<div class="block">Configures the publications of this project.
 <p>
 The publications container defines the outgoing publications of the project. That is, the consumable representations of things produced
 by building the project. An example of a publication would be an Ivy Module (i.e. <code>ivy.xml</code> and artifacts), or
 Maven Project (i.e. <code>pom.xml</code> and artifacts).
 <p>
 Actual publication implementations and the ability to create them are provided by different plugins. The “publishing” plugin itself does not provide any publication types.
 For example, given that the 'maven-publish' plugin provides a <a href="../../../../org/gradle/api/publish/maven/MavenPublication.html" title="interface in org.gradle.api.publish.maven"><code>MavenPublication</code></a> type, you can create a publication like:
 <pre class='autoTested'>
 apply plugin: 'maven-publish'

 publishing {
   publications {
     myPublicationName(MavenPublication) {
       // Configure the publication here
     }
   }
 }
 </pre>
 <p>
 Please see <a href="../../../../org/gradle/api/publish/ivy/IvyPublication.html" title="interface in org.gradle.api.publish.ivy"><code>IvyPublication</code></a> and <a href="../../../../org/gradle/api/publish/maven/MavenPublication.html" title="interface in org.gradle.api.publish.maven"><code>MavenPublication</code></a> for more information on publishing in these specific formats.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>configure</code> - The action or closure to configure the publications with.</dd></dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar_bottom">
<!--   -->
</a><a href="#skip-navbar_bottom" title="Skip navigation links"></a><a name="navbar_bottom_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-all.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../org/gradle/api/publish/PublicationContainer.html" title="interface in org.gradle.api.publish"><span class="strong">Prev Class</span></a></li>
<li>Next Class</li>
</ul>
<ul class="navList">
<li><a href="../../../../index.html?org/gradle/api/publish/PublishingExtension.html" target="_top">Frames</a></li>
<li><a href="PublishingExtension.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field_summary">Field</a>&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field_detail">Field</a>&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
